#!/usr/bin/python

import	re
import	string

parts = \
	[
	'block',
	'button',
	'check',
	'choice',
	'field',
	'formblock',
	'form',
	'framer',
	'item',
	'label',
	'link',
	'linktree',
	'listbox',
	'object',
	'richtext',
	'stackpage',
	'stack',
	'tabberpage',
	'tabber'
	]

p_kjs = re.compile(r'^[^/].*id_([A-Za-z]+).*')
p_py  = re.compile(r'^[^/].*PY_METHOD.*\(([A-Za-z]+),.*')

for part in parts :
    try :
        man = open('script/kjs/doc/kb_kjs' + part + '.man').read()
    except :
        print "kjs: %-12s: no manual file" % part
        continue
    for line in open('script/kjs/kb_' + part + 'proxy.h').readlines() :
        m = p_kjs.match(line)
        if not m :
            continue
        if string.find (man, 'name="%s"' % m.group(1)) < 0 :
            print "kjs: %-12s: %-20s: not found" % (part, m.group(1))

for part in parts :
    try :
        man = open('script/python/doc/kb_py' + part + '.man').read()
    except :
        print "py : %-12s: no manual file" % part
        continue
    for line in open('script/python/kb_py' + part + '.cpp').readlines() :
        m = p_py.match(line)
        if not m :
            continue
        if string.find (man, 'name="%s"' % m.group(1)) < 0 :
            print "py : %-12s: %-20s: not found" % (part, m.group(1))

