import	rkLocator

def Scan (settings) :

    disabled = settings.disabled ('mysql', 'mysqlBuild', 'mysqlIncDir', 'mysqlLibDir', 'mysqlLibLib')
    if disabled is not None :
        return disabled


    incList	= \
		[
		settings.lookup ('with-mysql-includes'),
		'/usr/include',
		'/usr/include/mysql',
		'/usr/local/include',
		'/usr/local/include/mysql'
		]

    libList	= \
		[
		settings.lookup ('with-mysql-libraries'),
		'/usr/lib',
		'/usr/lib/mysql',
		'/usr/local/lib',
		'/usr/local/lib/mysql'
		]

    if settings.mode() in [ 'win' ] :
        libFile = 'libmysql.lib'
        libLib  = 'libmysql'

    if settings.mode() in [ 'mingw' ] :
        libFile = 'libmysql.a'
        libLib  = 'mysql'

    if settings.mode() in [ 'mac' ] :
        libFile = 'libmysqlclient.a'
        libLib  = 'mysqlclient'

    if settings.mode() in [ 'kde', 'qt3' ] :
        libFile = 'libmysqlclient.so'
        libLib  = 'mysqlclient'

    incDir = rkLocator.locateFile ('mysql.h', incList)
    libDir = rkLocator.locateFile (libFile,   libList)
    text   = ''

    if incDir :
        settings.log ('Checking for MySQL includes', incDir)
        text = text + "mysqlIncDir = r'%s'\n" % (incDir)
    else      :
        settings.log ('Checking for MySQL includes', 'not found')
        text = text + "mysqlIncDir = None\n"

    if libDir : 
        settings.log ('Checking for MySQL libraries', libDir)
        text = text + "mysqlLibDir = r'%s'\n" % (libDir)
        text = text + "mysqlLibLib = '%s'\n"  % (libLib)
    else      :
        settings.log ('Checking for MySQL libraries', 'not found')
        text = text + "mysqlLibDir = None\n"
        text = text + "mysqlLibLib = None\n"

    if incDir is not None and libDir is not None :
        text = text + "mysqlBuild  = 1\n"
    else :
        text = text + "mysqlBuild  = 0\n"
        settings.warning ('MySQL components not found - no mysql driver')

    return text

def Help (settings) :

    print "	--enable-mysql=yes|no		: Enable MySQL build (default yes)"
    print "	--with-mysql-includes=dir	: Set MySQL include directory"
    print "	--with-mysql-libraries=dir	: Set MySQL library directory"

def Make (settings, dir) :

    settings.make (dir)
