import	rkLocator

def Scan (settings) :

    disabled = settings.disabled ('odbc', 'odbcBuild', 'odbcIncDir', 'odbcLibDir', 'odbcLibLib')
    if disabled is not None :
        return disabled

    incList	= \
		[
		settings.lookup ('with-odbc-includes'),
		'/usr/include',
		'/usr/local/include'
		]

    libList	= \
		[
		settings.lookup ('with-odbc-libraries'),
		'/usr/lib',
		'/usr/local/lib'
		]

    if settings.mode() in [ 'win', 'mingw' ] :
        libFile = 'odbc32.lib'
        libLib  = 'odbc32'

    if settings.mode() in [ 'kde', 'qt3'] :
        libFile = 'libodbc.so'
        libLib  = 'odbc'

    if settings.mode() in [ 'mac' ] :
        libFile = 'libodbc.dylib'
        libLib  = 'odbc'


    incDir = rkLocator.locateFile ('sqlext.h',	 incList)
    libDir = rkLocator.locateFile (libFile,      libList)

    text   = ''

    if incDir :
        settings.log ('Checking for ODBC includes', incDir)
        text = text + "odbcIncDir = r'%s'\n" % (incDir)
    else      :
        settings.log ('Checking for ODBC includes', 'not found')
        text = text + "odbcIncDir = None\n"

    if libDir : 
        settings.log ('Checking for ODBC libraries', libDir)
        text = text + "odbcLibDir = r'%s'\n" % (libDir)
        text = text + "odbcLibLib = '%s'\n"  % (libLib)
    else      :
        settings.log ('Checking for ODBC libraries', 'not found')
        text = text + "odbcLibDir = None\n"
        text = text + "odbcLibLib = None\n"


    if incDir is not None and libDir is not None :
        text = text + "odbcBuild  = 1\n"
    else :
        text = text + "odbcBuild  = 0\n"

    return text


def Help (settings) :

    print "	--with-odbc-includes=dir	: Set ODBC include directory"
    print "	--with-odbc-libraries=dir	: Set ODBC library directory"


def Make (settings, dir) :

    settings.make (dir)
