import	rkLocator

def Scan (settings) :

    disabled = settings.disabled ('pgsql', 'pgsqlBuild', 'pgsqlIncDir', 'pgsqlLibDir')
    if disabled is not None :
        return disabled


    incList	= \
		[
		settings.lookup ('with-pgsql-includes'),
		'/usr/include',
		'/usr/include/pgsql',
		'/usr/include/postgresql',
		'/usr/local/include',
		'/usr/local/include/pgsql'
		]

    libList	= \
		[
		settings.lookup ('with-pgsql-libraries'),
		'/usr/lib',
		'/usr/lib/pgsql',
		'/usr/local/lib',
		'/usr/local/lib/pgsql'
		]

    if settings.mode() in [ 'win', 'mingw' ] :
        libFile = 'libpq.lib'
        libLib  = 'libpq'

    if settings.mode() in [ 'kde', 'qt3' ] :
        libFile = 'libpq.so'
        libLib  = 'pq'

    if settings.mode() in [ 'mac' ] :
        libFile = 'libpq.dylib'
        libLib  = 'pq'

    incDir = rkLocator.locateFile ('libpq-fe.h', incList)
    libDir = rkLocator.locateFile (libFile,      libList)
    text   = ''

    if incDir :
        settings.log ('Checking for PgSQL includes', incDir)
        text = text + "pgsqlIncDir = r'%s'\n" % (incDir)
    else      :
        settings.log ('Checking for PgSQL includes', 'not found')
        text = text + "pgsqlIncDir = None\n"

    if libDir : 
        settings.log ('Checking for PgSQL libraries', libDir)
        text = text + "pgsqlLibDir = r'%s'\n" % (libDir)
        text = text + "pgsqlLibLib = '%s'\n"  % (libLib)
    else      :
        settings.log ('Checking for PgSQL libraries', 'not found')
        text = text + "pgsqlLibDir = None\n"
        text = text + "pgsqlLibLib = None\n"

    if incDir is not None and libDir is not None :
        text = text + "pgsqlBuild  = 1\n"
    else :
        text = text + "pgsqlBuild  = 0\n"
        settings.warning ('PgSQL components not found - no mysql driver')

    return text

def Help (settings) :

    print "	--enable-pgsql=yes|no		: Enable PgSQL build (default yes)"
    print "	--with-pgsql-includes=dir	: Set PgSQL include directory"
    print "	--with-pgsql-libraries=dir	: Set PgSQL library directory"

def Make (settings, dir) :

    settings.make (dir)
