import	rkLocator

def Scan (settings) :

    disabled = settings.disabled ('sqlite3', 'sqlite3Build', 'sqlite3IncDir', 'sqlite3LibDir', 'sqlite3LibLib')
    if disabled is not None :
        return disabled


    incList	= \
		[
		settings.lookup ('with-sqlite3-includes'),
		'/usr/include',
		'/usr/include/sqlite3',
		'/usr/local/include',
		'/usr/local/include/sqlite3'
		]

    libList	= \
		[
		settings.lookup ('with-sqlite3-libraries'),
		'/usr/lib',
		'/usr/lib/sqlite3',
		'/usr/local/lib',
		'/usr/local/lib/sqlite3'
		]

    if settings.mode() in [ 'win' ] :
        libFile = 'libsqlite3.lib'
        libLib  = 'libsqlite3'

    if settings.mode() in [ 'mingw' ] :
        libFile = 'libsqlite3.so'
        libLib  = 'sqlite3'

    if settings.mode() in [ 'mac' ] :
        libFile = 'libsqlite3.a'
        libLib  = 'sqlite3'

    if settings.mode() in [ 'kde', 'qt3' ] :
        libFile = 'libsqlite3.so'
        libLib  = 'sqlite3'

    incDir = rkLocator.locateFile ('sqlite3.h', incList)
    libDir = rkLocator.locateFile (libFile,     libList)
    text   = ''

    if incDir :
        settings.log ('Checking for sqlite3 includes', incDir)
        text = text + "sqlite3IncDir = r'%s'\n" % (incDir)
    else      :
        settings.log ('Checking for sqlite3 includes', 'not found')
        text = text + "sqlite3IncDir = None\n"

    if libDir : 
        settings.log ('Checking for sqlite3 libraries', libDir)
        text = text + "sqlite3LibDir = r'%s'\n" % (libDir)
        text = text + "sqlite3LibLib = '%s'\n"  % (libLib)
    else      :
        settings.log ('Checking for sqlite3 libraries', 'not found')
        text = text + "sqlite3LibDir = None\n"
        text = text + "sqlite3LibLib = None\n"

    if incDir is not None and libDir is not None :
        text = text + "sqlite3Build  = 1\n"
    else :
        text = text + "sqlite3Build  = 0\n"
        settings.warning ('sqlite3 components not found - no sqlite3 driver')

    return text

def Help (settings) :

    print "	--enable-sqlite3=yes|no		: Enable sqlite3 build (default yes)"
    print "	--with-sqlite3-includes=dir	: Set sqlite3 include directory"
    print "	--with-sqlite3-libraries=dir	: Set sqlite3 library directory"

def Make (settings, dir) :

    settings.make (dir)
