<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:import href="m_common.xsl"/>

<xsl:template match="/section">
    <html>
    <head>
      <xsl:for-each select="title">
        <title>
          <xsl:value-of select="text()"/>
        </title>
      </xsl:for-each>
    </head>
    <body>
        <xsl:apply-templates/>
    </body>
    </html>
</xsl:template>

<xsl:template match="/section/title">
    <h1>
        <xsl:apply-templates/>
    </h1>
</xsl:template>

<xsl:template match="sect2">
    <xsl:variable name="name"><xsl:value-of select="@id"/></xsl:variable>
    <a name="{$name}"/>
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="sect2/title">
    <font size="+1" color="blue">
        <xsl:apply-templates/>
    </font>
</xsl:template>

<xsl:template match="sect3/title">
    <h3>
        <xsl:apply-templates/>
    </h3>
</xsl:template>

</xsl:stylesheet>
