#!/bin/sh

TARGET=$1
TGTDIR=`dirname $TARGET`
TOPDIR=`pwd`

(
	cd	$TGTDIR

	rm -rf	manual
	mkdir	manual
	mkdir	manual/rekall

	for d in `find . -maxdepth 1 -name 'chap[0-9]*' -type d`
	do
		cp -a $d manual/rekall
	done
	for d in `find . -maxdepth 1 -name 'app[0-9]*' -type d`
	do
		cp -a $d manual/rekall
	done

	cp	*.sgml			manual
	cp	index.docbook		manual

	(
	cd manual
	meinproc --stylesheet `pwd`/../m_flat.xsl --output ../index.xml index.docbook
	)

	rm -f	manual/*.sgml

	./mkman.py

	tar -czf  $TOPDIR/doc/rekall/manual.tgz manual index.xml
#	zip -r -o $TOPDIR/doc/rekall/manual.zip manual index.xml
)
