#!/bin/sh

rm -rf	manual
mkdir	manual

for d in `find . -maxdepth 1 -name 'chap[0-9]*' -type d`
do
	mkdir	manual/$d

	(
		cd $d

		for f in *.png
		do
			convert -enhance -geometry 50% $f ../manual/$d/$f
		done
	)
done

cp	*.sgml			manual
cp	index.docbook		manual


(
	cd manual
	meinproc --stylesheet `pwd`/../m_flat.xsl --output ../index.xml index.docbook
)

rm -f	manual/*.sgml
rm -r	manual/index.docbook

./mkman.py
tar -czf manual.tgz manual
