/***************************************************************************
    file	         : editor.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qfileinfo.h>
#include	<qmainwindow.h>
#include	<qapplication.h>

#include	"kb_classes.h"
#include	"kb_textedit.h"



#if		__KB_KDE
#include	<kapp.h>
#include	<klocale.h>
#include	<kaboutdata.h>
#include	<kcmdlineargs.h>
#endif


int	main
	(	int	argc,
		char	*argv[]
	)
{
#if	__KB_KDE
	char *dummy[2]	;

	dummy[0] = (char *)"script" ;
	dummy[1] = 0	;

	KAboutData about (__KB_APPNAME,
			  I18N_NOOP("Rekall Editor Test"),
			  "0.0.0",
			  I18N_NOOP("Rekall: Editor test harness"),
			  KAboutData::License_Unknown,
			  "(c) 2000,2001,2002 by Series One Software",
			  0,
			  "http://www.rekall.a-i-s.co.uk",
			  "mike@quaking.demon.co.uk"
			 ) ;
	about.addAuthor  ("Mike Richardson", 0, "mike@quaking.demon.co.uk") ; 
	about.addAuthor  ("John Dean", 	     0, "john@rygannon.com") ; 

	KCmdLineArgs::init (2, dummy, &about) ;

	KApplication	app	;
#endif
#if	__KB_TKC
	QApplication	app	(argc, argv) ;
#endif

#ifdef	Q_OS_MACX
	extern	void	setRootDir (const QString &)	;
	QString	rootDir	= QFileInfo(argv[0]).dirPath()	;
	setRootDir (rootDir.left(rootDir.findRev('/')))	;
#endif

	extern	void    registerAllNodes() ;
	registerAllNodes   () ;

	KBError		error	;

	argc	-= 1	;
	argv	+= 1	;

	while ((argc > 0) && (qstrncmp (argv[0], "--", 2) == 0))
	{
		fprintf	(stderr, "usage: editor\n") ;
		exit	(1) ;
	}

	if (argc != 0)
	{
		fprintf	(stderr, "usage: editor\n") ;
		exit	(1) ;
	}

	QMainWindow	window	;
	KBTextEdit	editor	(&window) ;
	editor.showSkeleton	(true)	  ;

	window.setCentralWidget (&editor) ;

	window.show() ;
	app   .exec() ;
	return	0 ;
}
