/***************************************************************************
    file	         : skindlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qfileinfo.h>
#include	<qmainwindow.h>
#include	<qapplication.h>

#include	"kb_classes.h"
#include	"kb_skin.h"
#include	"kb_skindlg.h"
#include	"kb_dom.h"



#if		__KB_KDE
#include	<kapp.h>
#include	<klocale.h>
#include	<kaboutdata.h>
#include	<kcmdlineargs.h>
#endif


int	main
	(	int	argc,
		char	*argv[]
	)
{
#if	__KB_KDE
	char *dummy[2]	;

	dummy[0] = (char *)"script" ;
	dummy[1] = 0	;

	KAboutData about (__KB_APPNAME,
			  I18N_NOOP("Rekall SkinDlg Test"),
			  "0.0.0",
			  I18N_NOOP("Rekall: SkinDlg test harness"),
			  KAboutData::License_Unknown,
			  "(c) 2000,2001,2002 by Series One Software",
			  0,
			  "http://www.rekall.a-i-s.co.uk",
			  "mike@quaking.demon.co.uk"
			 ) ;
	about.addAuthor  ("Mike Richardson", 0, "mike@quaking.demon.co.uk") ; 
	about.addAuthor  ("John Dean", 	     0, "john@rygannon.com") ; 

	KCmdLineArgs::init (2, dummy, &about) ;

	KApplication	app	;
#endif
#if	__KB_TKC
	QApplication	app	(argc, argv) ;
#endif

#ifdef	Q_OS_MACX
	extern	void	setRootDir (const QString &)	;
	QString	rootDir	= QFileInfo(argv[0]).dirPath()	;
	setRootDir (rootDir.left(rootDir.findRev('/')))	;
#endif

	extern	void    registerAllNodes() ;
	registerAllNodes   () ;

	KBError		error	;

	argc	-= 1	;
	argv	+= 1	;

	while ((argc > 0) && (qstrncmp (argv[0], "--", 2) == 0))
	{
		fprintf	(stderr, "usage: skindlg\n") ;
		exit	(1) ;
	}

	if (argc != 0)
	{
		fprintf	(stderr, "usage: skindlg\n") ;
		exit	(1) ;
	}

	KBSkinDlg	skinDlg	(0) ;
	KBDomDocument	defn	;

	fprintf
	(	stderr,
		"skindlg: trying to load\n"
	)	;

	if (defn.loadFile ("skin.skn", 0))
	{
		KBSkin	skin	(defn.documentElement()) ;
		skinDlg.load	(skin)	;
	}
	else	fprintf
		(	stderr,
			"skin: %s\n",
			defn.lastError().getMessage().latin1()
		)	;

	if (skinDlg.exec())
	{
		KBSkin	skin		;
		QDomDocument	doc	;
		QDomElement	root	= doc.createElement ("skin") ;
		doc.appendChild	(root)			;
		skinDlg.save	(skin, "skinname") 	;
		skin.save	(root)			;

		QFile	 file	("skin.skn") 		;
		QCString text	= doc.toString().utf8()	; 
		file.open	(IO_WriteOnly)		;
		file.writeBlock	(text.data(), text.length()) ;
	}

	return	0 ;
}
