/***************************************************************************
    file	         : kb_wizruntime.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	"kb_dbinfo.h"
#include	"kb_serverinfo.h"
#include	"kb_location.h"
#include	"kb_loader.h"
#include	"kb_wizruntime.h"

#include	"kb_locator.h"


KBWizardRuntime::KBWizardRuntime
	(	KBDBInfo	*dbInfo,
		const QString	&server
	)
	:
	KBWizard (dbInfo, server)
{
}

int	KBWizardRuntime::execute
	(	int		startPage
	)
{
	QString	wizXML = locateFile ("appdata", "wizards/wizRuntime.wiz") ;
	if (wizXML.isNull())
	{
		KBError::EError
		(	QString(TR("Cannot locate wizard specification")),
			"wizRuntime.wiz",
			__ERRLOCN
		)	;
		return	0 ;
	}

	if (!init (wizXML))
	{	lastError().DISPLAY() ;
		return	0 ;
	}

	extern	void recentDatabases (QStringList &, QStringList &) ;
	QStringList fileList ;
	QStringList infoList ;
	recentDatabases (fileList, infoList) ;
	if (fileList.count() == 0)
		startPage = 3 ;

	return	KBWizard::execute (startPage) ;
}

QString	KBWizardRuntime::database ()
{
	return	ctrlValue ("runtime", "recentdb") ;
}

