#include	"rk_groupbox.moc"

RKGroupBox::RKGroupBox
	(	int		strips,
		Orientation	orientation,
		const QString	&title,
		RKWidget	*parent
	)
	:
	RKFrame		(parent),
	m_strips	(strips),
	m_orientation	(orientation)
{
	if (m_strips <= 0) m_strips = 1 ;
	m_free	  = 0	;
	m_current = 0 	;

	gtk_frame_set_label (GTK_FRAME(gtkWidget()), title.latin1()) ;

	if (m_orientation == Vertical)
		m_top = gtk_hbox_new(false, 0) ;
	else	m_top = gtk_vbox_new(false, 0) ;

	gtk_container_add   (GTK_CONTAINER(gtkWidget()), m_top) ;	
	gtk_widget_show     (m_top) ;
}

void	RKGroupBox::gtkInsertChild
	(	GtkWidget	*child
	)
{
	fprintf
	(	stderr,
		"RKGroupBox::gtkInsertChild: m_free=%d\n",
		m_free
	)	;

	if (m_free == 0)
	{
		if (m_orientation == Vertical)
			m_current = gtk_vbox_new(false, 0) ;
		else	m_current = gtk_hbox_new(false, 0) ;

		gtk_box_pack_start (GTK_BOX(m_top), m_current, false, false, 0) ;
		gtk_widget_show    (m_current) ;

		m_groups.append (m_current) ;
		m_free	= m_strips ;
	}

	gtk_box_pack_start (GTK_BOX(m_current), child, false, false, 0) ;
	m_free	-= 1	;
}

