/***************************************************************************
    file	         : rk_messagebox.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<gtk/gtk.h>

#include	"rk_widget.h"
#include	"rk_messagebox.h"


static	GtkWindow *getWindow
	(	  RKWidget	*widget
	)
{
	if (widget == 0) return 0 ;
	return	GTK_WINDOW(gtk_widget_get_ancestor(widget->gtkWidget(),GTK_TYPE_WINDOW)) ;
}

int	RKMessageBox::questionYesNo
	(	RKWidget	*parent,
		const QString	&text,
		const QString	&caption,
		const QString	&buttonYes,
		const QString	&buttonNo,
		bool		
	)
{
	QString	bYes	= buttonYes	;
	QString	bNo	= buttonNo	;

	if (bYes.isEmpty()) bYes = "Yes" ;
	if (bNo .isEmpty()) bNo  = "No " ;

	GtkWidget *mb = gtk_message_dialog_new
			(	getWindow(parent),
				GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_QUESTION,
				GTK_BUTTONS_YES_NO,
				"%s",
				text.latin1()
			)	;
	gtk_window_set_title (GTK_WINDOW(mb), caption.latin1()) ;

	int	  rc  = gtk_dialog_run	(GTK_DIALOG(mb)) ;
	gtk_widget_destroy (mb) ;
	
	return	  rc == GTK_RESPONSE_YES ?
			RKMessageBox::Yes : RKMessageBox::No ;
}


void	RKMessageBox::sorry
	(	RKWidget	*parent,
		const QString	&text,
		const QString	&caption,
		bool		
	)
{
	GtkWidget *mb = gtk_message_dialog_new
			(	getWindow(parent),
				GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_ERROR,
				GTK_BUTTONS_OK,
				"%s",
				text.latin1()
			)	;
	gtk_window_set_title (GTK_WINDOW(mb), caption.latin1()) ;
	gtk_dialog_run	     (GTK_DIALOG(mb)) ;
	gtk_widget_destroy   (mb) ;
}

void	RKMessageBox::information
	(	RKWidget	*parent,
		const QString	&text,
		const QString	&caption,
		const QString	&,
		bool		
	)
{
	GtkWidget *mb = gtk_message_dialog_new
			(	getWindow(parent),
				GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"%s",
				text.latin1()
			)	;
	gtk_window_set_title (GTK_WINDOW(mb), caption.latin1()) ;
	gtk_dialog_run	     (GTK_DIALOG(mb)) ;
	gtk_widget_destroy   (mb) ;
}
