#include	"rk_pushbutton.moc"

bool	RKPushButton::sigButtonPressed
	(	GtkButton	*,
		gpointer	data
	)
{
	((RKPushButton *)data)->pressed () ;
	return	false	;
}

bool	RKPushButton::sigButtonReleased
	(	GtkButton	*,
		gpointer	data
	)
{
	((RKPushButton *)data)->released () ;
	return	false	;
}

bool	RKPushButton::sigButtonClicked
	(	GtkButton	*,
		gpointer	data
	)
{
	((RKPushButton *)data)->clicked () ;
	return	false	;
}

RKPushButton::RKPushButton
	(	RKWidget	*parent,
		const char	*name,
		WFlags		flags
	)
	:
	RKWidget (gtk_button_new (), parent, name, flags)
{
	wireUp	() ;
}

RKPushButton::RKPushButton
	(	const QString	&text,
		RKWidget	*parent,
		const char	*name,
		WFlags		flags
	)
	:
	RKWidget (gtk_button_new (), parent, name, flags)
{
	wireUp	()	;
	setText	(text)	;
}

RKPushButton::~RKPushButton ()
{
}

void	RKPushButton::wireUp ()
{
	g_signal_connect
	(	G_OBJECT(gtkWidget()),
		"pressed",
		G_CALLBACK(sigButtonPressed),
		(gpointer)this
	)	;
	g_signal_connect
	(	G_OBJECT(gtkWidget()),
		"released",
		G_CALLBACK(sigButtonReleased),
		(gpointer)this
	)	;
	g_signal_connect
	(	G_OBJECT(gtkWidget()),
		"clicked",
		G_CALLBACK(sigButtonClicked),
		(gpointer)this
	)	;
}

void	RKPushButton::setText
	(	const QString	&text
	)
{
	gtk_button_set_label ((GtkButton *)gtkWidget(), text.latin1()) ;
}
