/***************************************************************************
    file	         : rk_dcop.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"rk_dcop.h"
#include	"rk_dcopbase.h"

#include	<dcopclient.h>

class	RKDCOPWrapper : public RKDCOPBase
{
	K_DCOP

	RKDCOPObject	*m_parent	 ;

public	:

	RKDCOPWrapper	(RKDCOPObject *, const char *) ;
}	;

RKDCOPWrapper::RKDCOPWrapper
	(	RKDCOPObject	*parent,
		const char	*name
	)
	:
	RKDCOPBase	(name)
{
	m_parent = parent ;
}


bool	RKDCOPWrapper::process
	(	const QCString		&func,
		const QByteArray	&args,
		QCString		&replyType,
		QByteArray		&replyData
	)
{
	return	m_parent->process (func, args, replyType, replyData) ;
}

QCStringList
	RKDCOPWrapper::functions  ()
{
	return	m_parent->functions  () ;
}

QCStringList
	RKDCOPWrapper::interfaces ()
{
	return	m_parent->interfaces () ;
}

/*  ------------------------------------------------------------------	*/

RKDCOPObject::RKDCOPObject
	(	const char	*name
	)
	:
	DCOPObject (name)
{
	m_wrapper = new RKDCOPWrapper (this, name) ;
}

RKDCOPObject::~RKDCOPObject ()
{
	delete	m_wrapper ;
}

QCString RKDCOPObject::normalizeFunctionSignature
	 (	const QCString	&func
	 )
{
	return	DCOPClient::normalizeFunctionSignature (func) ;
}
