from	SCons.Builder		import	Builder
from	SCons.Environment	import	Environment
from	SCons.Action		import	Action

import	rkConfig
import	os
import	string


def processDesktop (target, source, env) :

    print  "Desktop: build '%s' from '%s' prefix '%s'" % (str(target[0]), str(source[0]), rkConfig.libPrefix)
    text   = open(str(source[0])).read()
    text   = string.replace(text, '!{LIBPREFIX}', rkConfig.libPrefix)
    open(str(target[0]), 'w').write(text)
    return None



def makeDesktopFile (file) :

    builder = Builder \
	    (
		action		= processDesktop,
		suffix		= '.desktop',
		src_suffix	= '.desktop_proto'
	    )

    env	    = Environment \
	    (
		ENV		= { 'PATH'     : os.environ['PATH'] },
		BUILDERS	= { 'Desktop'  : builder  }
	    )

    env.Desktop (file)
