from	SCons.Builder		import	Builder
from	SCons.Environment	import	Environment

import	rkConfig
import	rkBuilder
import	re

patt	= re.compile ('#include.*"(.+)\\.moc"')

def generateMocFiles (dir, sources = None) :

    import os

    builder = Builder \
	    (
#		action		= rkConfig.qt3BinDir + '/moc $SOURCE -p . -o $TARGET',
		action		= rkConfig.qt3BinDir + '/moc $SOURCE -o $TARGET',
		suffix		= '.moc',
		src_suffix	= '.h'
	    )

    env	    = Environment \
	    (
		ENV		= { 'PATH' : os.environ['PATH'] },
		BUILDERS	= { 'Moc'  : builder  }
	    )


    if sources is None :
        sources = []
        for file in os.listdir(rkConfig.topDir + '/' + dir) :
            if file[-4:] == '.cpp' :
                sources.append (file)

    for file in sources :
        f = open(rkConfig.topDir + '/' + dir + '/' + file)
        l = f.readline()
        while l :
            m = patt.match (l)
            if m :
                env.Moc (m.group(1))
                break
            l = f.readline()
