import	rkLocator
import	os

def Scan (settings) :

    incList	= \
		[
		settings.lookup ('with-cppunit-includes'),
		'/usr/include',
		'/usr/local/include'
		]

    libList	= \
		[
		settings.lookup ('with-cppunit-libraries'),
		'/usr/lib',
		'/usr/local/lib'
		]

    if settings.mode() in [ 'win' ] :
        libFile    = 'cppunit_dll.lib'
        libLib     = 'cppunit_dll'
        libFileQT  = 'qttestrunner_dll.lib'
        libLibQT   = 'qttestrunner_dll'

    if settings.mode() in [ 'mingw' ] :
        libFile    = 'cppunit_dll.a'
        libLib     = 'cppunit_dll'
        libFileQT  = 'qttestrunner_dll.a'
        libLibQT   = 'qttestrunner_dll'

    if settings.mode() in [ 'mac' ] :
        libFile    = 'libcppunit.dylib'
        libLib     = 'cppunit'
        libFileQT  = 'libqttestrunner.dylib'
        libLibQT   = 'libqttestrunner'

    if settings.mode() in [ 'kde', 'qt3' ] :
        libFile    = 'libcppunit.so'
        libLib     = 'cppunit'
        libFileQT  = 'libqttestrunner.so'
        libLibQT   = 'qttestrunner'

    incDir   = rkLocator.locateFile (os.path.join('cppunit', 'Test.h'), incList)
    libDir   = rkLocator.locateFile (libFile,   libList)
    libDirQT = rkLocator.locateFile (libFileQT, libList)
    text     = ''

    if incDir :
        settings.log ('Checking for CPPUnit includes', incDir)
        text = text + "cppunitIncDir = r'%s'\n" % (incDir)
    else      :
        settings.log ('Checking for CPPUnit includes', 'not found (only needed for unit test suite)')
        text = text + "cppunitIncDir = None\n"

    if libDir : 
        settings.log ('Checking for CPPUnit libraries', libDir)
        text = text + "cppunitLibDir = r'%s'\n" % (libDir)
        text = text + "cppunitLibLib = '%s'\n"  % (libLib)
    else      :
        settings.log ('Checking for CPPUnit libraries', 'not found (only needed for unit test suite)')
        text = text + "cppunitLibDir = None\n"
        text = text + "cppunitLibLib = None\n"

    if libDirQT : 
        settings.log ('Checking for CPPUnit QT libraries', libDirQT)
        text = text + "cppunitLibDirQT = r'%s'\n" % (libDirQT)
        text = text + "cppunitLibLibQT = '%s'\n"  % (libLibQT)
    else      :
        settings.log ('Checking for CPPUnit QT libraries', 'not found (only needed for unit test suite)')
        text = text + "cppunitLibDirQT = None\n"
        text = text + "cppunitLibLibQT = None\n"

    if incDir is not None and libDir is not None :
        text = text + "cppunitBuild  = 1\n"
    else :
        text = text + "cppunitBuild  = 0\n"

    return text

def Make (settings, dir) :

    settings.make (dir)

