import	rkLocator

def Scan (settings) :

    text   = ''

    if settings.lookup ('mode') == 'kde' :

        if settings.lookup('enable-kjs') == 'yes' :

            print 'Enabling (KDE) KJS scripting'
            text = text + 'kjsBuild = 1\n'
            return text

        text = text + 'kjsBuild = 0\n'
        return text


    if settings.lookup('enable-kjs') == 'yes' :

        incList	= \
		[
		settings.lookup ('with-pcre-includes'),
		'/usr/include',
		'/usr/include/pcre',
		'/usr/local/include',
		'/usr/local/include/pcre'
		]

        libList	= \
		[
		settings.lookup ('with-pcre-libraries'),
		'/usr/lib',
		'/usr/lib/pcre',
		'/usr/local/lib',
		'/usr/local/lib/pcre'
		]

        if settings.mode() in [ 'win' ] :
            libFile = 'libpcre.lib'
            libLib  = 'libpcre'

        if settings.mode() in [ 'mingw' ] :
            libFile = 'libpcre.a'
            libLib  = 'libpcre'

        if settings.mode() in [ 'mac' ] :
            libFile = 'libpcre.a'
            libLib  = 'pcre'

        if settings.mode() in [ 'qt3' ] :
            libFile = 'libpcre.so'
            libLib  = 'pcre'

        incDir = rkLocator.locateFile ('pcre.h', incList)
        libDir = rkLocator.locateFile (libFile,   libList)
        text   = ''

        if incDir :
            settings.log ('Checking for PCRE includes', incDir)
            text = text + "pcreIncDir = r'%s'\n" % (incDir)
        else      :
            settings.log ('Checking for PCRE includes', 'not found')
            text = text + "pcreIncDir = None\n"

        if libDir : 
            settings.log ('Checking for PCRE libraries', libDir)
            text = text + "pcreLibDir = r'%s'\n" % (libDir)
            text = text + "pcreLibLib = '%s'\n"  % (libLib)
        else      :
            settings.log ('Checking for PCRE libraries', 'not found')
            text = text + "pcreLibDir = None\n"
            text = text + "pcreLibLib = None\n"

        if incDir is not None and libDir is not None :
            print 'Enabling (non-KDE) KJS scripting'
            text = text + "pcreBuild  = 1\n"
            text = text + 'kjsBuild = 1\n'
            text = text + "kdever = '3.4.1'\n"
            text = text + "kdeverno = '030401'\n"
        else :
            text = text + "pcreBuild  = 0\n"
            settings.warning ('PCRE components not found - no KJS scriptint')
            text = text + 'kjsBuild = 0\n'
            text = text + "kdever = None\n"
            text = text + "kdeverno = None\n"

        return text


    text = text + 'kjsBuild = 0\n'
    return text



def Help (settings) :

    print "	--enable-kjs=yes		: Enable KJS scripting"

