import	rkLocator
import	sys
import	os

def Scan (settings) :

    qti = settings.lookup ('with-qt-includes' )
    qtl = settings.lookup ('with-qt-libraries')
    qtb = settings.lookup ('with-qt-binaries' )
    qtd = settings.lookup ('with-qt-dir'      )

    if (qti is None or qti == '') and (qtd is not None) :
        qti = os.path.join (qtd, 'include')

    if (qtl is None or qtl == '') and (qtd is not None) :
        qtl = os.path.join (qtd, 'lib')

    if (qtb is None or qtb == '') and (qtd is not None) :
        qtb = os.path.join (qtd, 'bin')

    incList	= \
		[
		qti,
		settings.lookup ('prefix', 'include'),
		settings.env    ('QTDIR',  'include'),
		'/usr/include/qt3',
		'/usr/lib/qt3/include',
		'/usr/local/lib/qt3/include'
		]

    libList	= \
		[
		qtl,
		settings.lookup ('prefix', 'lib'),
		settings.env    ('QTDIR',  'lib'),
		'/usr/lib',
		'/usr/lib/qt3/lib',
		'/usr/local/lib/qt3/lib'
		]

    binList	= \
		[
		qtb,
		settings.lookup ('prefix', 'bin'),
		settings.env    ('QTDIR',  'bin'),
		'/usr/bin',
		'/opt/kde3/bin',
		'/usr/lib/qt3/bin',
		'/usr/local/lib/qt3/bin'
		]


    incDir = rkLocator.locateFile ('qapplication.h', incList)
    libVer = 'unset'
    libDir = None
    libLib = None
    binDir = None

    if settings.lookup('mode') in [ 'win' ] :
        for qtv in [ '336', '335', '334', '333', '3' ] :
            ql = 'qt-mt' + qtv
            ld = rkLocator.locateFile (ql + '.lib', libList)
            if ld is not None :
                libVer = qtv
                libDir = ld
                libLib = ql
                break
        binDir = rkLocator.locateFile ('moc.exe', binList)

    if settings.lookup('mode') in [ 'mingw' ] :
        libDir = rkLocator.locateFile ('libqt-mt.a',       libList)
        libLib = 'qt-mt'
        binDir = rkLocator.locateFile ('moc', binList)

    if settings.lookup('mode') in [ 'mac' ] :
        pair   =  rkLocator.locateLibPair \
			(	[
				  [ 'libqt-mt.3.dylib', 'qt-mt' ],
				  [ 'libqt.3.dylib',    'qt'    ]
				],
				libList
			)
        libDir = pair[0]
        libLib = pair[1]
        binDir = rkLocator.locateFile ('moc', binList)

    if settings.lookup('mode') in [ 'kde', 'qt3', 'qte' ] :
        libDir = rkLocator.locateFile ('libqt-mt.so',   libList)
        libLib = 'qt-mt'
        binDir = rkLocator.locateFile ('moc', binList)


    text   = ''

    if incDir is None :
        settings.log   ('Checking for QT3 includes', 'not found')
        settings.fatal ('Cannot find QT3 include files')
    else :
        settings.log   ('Checking for QT3 includes',  incDir)

    if libDir is None :
        settings.log   ('Checking for QT3 libraries', 'not found')
        settings.fatal ('Cannot find QT3 libraries')
    else :
        settings.log   ('Checking for QT3 libraries', libDir, libLib)

    if binDir is None :
        settings.log   ('Checking for QT3 binaries', 'not found')
        settings.fatal ('Cannot find QT3 binaries')
    else :
        settings.log   ('Checking for QT3 binaries',  binDir)


    text = text + "qt3IncDir = r'%s'\n" % (incDir)
    text = text + "qt3LibDir = r'%s'\n" % (libDir)
    text = text + "qt3LibLib = '%s'\n"  % (libLib)
    text = text + "qt3LibVer = '%s'\n"  % (libVer)
    text = text + "qt3BinDir = r'%s'\n" % (binDir)

    if settings.lookup ('mode') in ['qt3', 'qte', 'win', 'mingw', 'mac'] :

        prefix = settings.lookup ('prefix')
        if prefix is None : prefix = '/usr/local'
        text = text + "prefix = r'%s'\n" % (prefix)

    qteh = open(incDir + '/qtextedit.h'   ).read()
    qtbh = open(incDir + '/qtextbrowser.h').read()
    emlc = 0

    import re
    for line in open(incDir + '/qtextedit.h'   ).readlines() :
        if re.match ('.*virtual[ \t]*void[ \t]*emitLinkClicked.*', line) :
            emlc = emlc + 1
            break
    for line in open(incDir + '/qtextbrowser.h').readlines() :
        if re.match ('.*void[ \t]*emitLinkClicked.*', line) :
            emlc = emlc + 1
            break

    if emlc < 2 :
        settings.log ('QT headers appear to lack "emitLinkClicked"')
        text = text + 'emitLinkClicked = 0\n'
    else :
        text = text + 'emitLinkClicked = 1\n'


    return text


def Help (settings) :

    print "	--with-qt-includes=dir		: Set QT3 include directory"
    print "	--with-qt-libraries=dir		: Set QT3 library directory"
    print "	--with-qt-binaries=dir		: Set QT3 binaries directory"
