import	os
import	re
import	rkBuilder

#  rkWalker
#  --------
#  Directory tree walker, used for install scanning. Call instances implement
#  __getitem__ so that it can be treated as a list. Returns 3-element lists
#  comprising the full directory path, the path from the starting point
#  directory, and the file name.
#
class rkWalker :

    def __init__ (self, dir, pattern = None) :

        self.m_dlen  = len(dir)
        self.m_stack = [ dir ]
        self.m_files = []
        self.m_index = 0

        if pattern : self.m_pattern = re.compile (pattern)
        else       : self.m_pattern = None

    def __getitem__ (self, index) :

        while 1 :

            try :
                file = self.m_files[self.m_index]
                self.m_index = self.m_index + 1

            except IndexError :
                self.m_dir   = self.m_stack.pop ()
                self.m_files = os.listdir (self.m_dir)
                self.m_index = 0

            else :
                name = os.path.join(self.m_dir, file)
                if file[0:3] ==  "CVS" :
                    continue
                if file[0:4] == ".svn" :
                    continue
                if os.path.isdir (name) :
                    if not os.path.islink (name) :
                        self.m_stack.append (name)
                    continue
                if self.m_pattern :
                    if not self.m_pattern.match (file) :
                        continue

                return [self.m_dir, '.' + self.m_dir[self.m_dlen:], file]


def install (ins, env, srce, dest, patt) :

    if ins :
        for [dir, tgt, file] in rkWalker(os.path.join(rkBuilder.getSourcePath(), srce), patt) :
            ins.Alias ('install', env.Install (os.path.join(rkBuilder.appDir, dest, tgt), os.path.join(dir, file)))
