  <class name="FormBlock" title="Form Block Methods" super="Block">
    <method name="gotoQueryRow" comment="Go to row by row number">
      <return type="void" comment=""/>
      <arg name="row" type="number" comment="Row number" opt="No"/>
      <description>
        Moves focus to the specified row.
      </description>
    </method>
    <method name="gotoQueryRowByKey" comment="Go to row by primary key">
      <return type="number" comment="Row number or negative on error"/>
      <arg name="key" type="any" comment="Target key" opt="No"/>
      <description>
        Moves focus to the row corresponding to the specified key. Should
        only be used where the records are returned from a single table
        (ie., not via a query which joins multiple tables).
      </description>
    </method>
    <method name="doAction" comment="Perform block level action">
      <return type="void" comment=""/>
      <arg name="action" type="number" comment="Action code" opt="No"/>
    </method>
    <method name="firstRecord" comment="To to first record">
      <return type="void" comment=""/>
    </method>
    <method name="previousRecord" comment="Go to previous record">
        <return type="void" comment=""/>
    </method>
    <method name="nextRecord" comment="Go to next record">
        <return type="void" comment=""/>
    </method>
    <method name="lastRecord" comment="Go to last record">
        <return type="void" comment=""/>
    </method>
    <method name="addRecord" comment="Add a new record">
        <return type="void" comment=""/>
    </method>
    <method name="saveRecord" comment="Save current record">
        <return type="void" comment=""/>
    </method>
    <method name="deleteRecord" comment="Delete current record">
        <return type="void" comment=""/>
    </method>
    <method name="startQuery" comment="Start a query">
        <return type="void" comment=""/>
    </method>
    <method name="executeQuery" comment="Execute a query">
        <return type="void" comment=""/>
    </method>
    <method name="cancelQuery" comment="Cancel a query">
        <return type="void" comment=""/>
    </method>
    <method name="reload" comment="Reload data from database">
        <return type="void" comment=""/>
    </method>
    <method name="saveAsNewRecord" comment="Save current record as new record">
        <return type="void" comment=""/>
    </method>
    <method name="invalidControls" comment="Get list of invalid controls">
      <return type="list" comment="List of invalid controls"/>
      <arg name="row" type="number" comment="Row number" opt="No"/>
      <arg name="required" type="bool" comment="True to return list if no controls set" opt="Yes"/>
      <arg name="recurse" type="bool" comment="True to recurse into nested blocks" opt="Yes"/>
    </method>
    <method name="changedControls" comment="Get list of changed controls">
      <return type="list" comment="List of changed controls"/>
      <arg name="row" type="number" comment="Row number" opt="No"/>
    </method>
  </class>
