/***************************************************************************
    file	         : api_script.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qapplication.h>
#include	<qstring.h>
#include	<qmap.h>
#include	<qlabel.h>

#include	"rk_application.h"
#include	"rk_lineedit.h"

#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_locator.h"
#include	"kb_location.h"
#include	"kb_display.h"
#include	"kb_form.h"
#include	"kb_label.h"
#include	"kb_field.h"
#include	"kb_choice.h"
#include	"kb_memo.h"
#include	"kb_textedit.h"
#include	"kb_richtext.h"
#include	"kb_qtrichtext.h"
#include	"kb_listbox.h"
#include	"kb_dom.h"

#include	"tester.h"
#include	"tester_kbase.h"
#include	"accessor.h"

#include	<cppunit/TestCase.h>
#include	<cppunit/TestCaller.h>
#include	<cppunit/TestSuite.h>
#include	<cppunit/extensions/HelperMacros.h>

#if		defined(__WIN32__)
#define		_STDSTR(s)	((s).isNull() ? "" : (std::string)(s).latin1())
#define		EXPORT_API	__declspec(dllexport)
#endif
#if		! defined(__WIN32__)
#define		_STDSTR(s)	(s)
#define		EXPORT_API
#endif



extern	CppUnit::Test	*formTestSuite	(const QMap<QString,QString> *) ;
extern	CppUnit::Test	*reportTestSuite(const QMap<QString,QString> *) ;

CppUnit::Test EXPORT_API *testSetup
	(	const QMap<QString,QString> *settings
	)
{
	CppUnit::TestSuite *suite = new CppUnit::TestSuite ("Api_Script") ;

	suite->addTest (formTestSuite	(settings))	;
	suite->addTest (reportTestSuite	(settings))	;
	return	suite	;
}


#include	"kb_libloader.h"
#include	"factory.h"

TESTFACTORY	(KBTestAPIScriptFactory,APIScript,rkt_api_script)
