/***************************************************************************
    file	         : tester.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__TESTER_H
#define	__TESTER_H

#include	<qstring.h>
#include	<qmap.h>
#include	<cppunit/Test.h>

#if		defined(__WIN32__)
#define		IMPORT_API	__declspec(dllimport)
#endif
#if		! defined(__WIN32__)
#define		IMPORT_API
#endif

class	KBDBInfo	;
class	KBError		;

extern	IMPORT_API
	int	rekallTest
	(	const char 	*cmd,
		int		argc,
		const char	**argv,
		CppUnit::Test	*(*setup) (const QMap<QString,QString> *)
	)	;

extern	IMPORT_API	bool		rekallTestVerbose  ()			;
extern	IMPORT_API	const char	*rekallTestCommand () 			;
extern	IMPORT_API	bool		rekallTestSkip	   (const QString &)	;
extern	IMPORT_API	void		rekallGUIPause	   (const QString &)	;
extern	IMPORT_API	QString		rekallTestError	   (const KBError &)	;
extern	IMPORT_API	KBDBInfo	*rekallDBInfo	   (const char *, const char *, const char * = "noname") ;

#if	__KB_RUNTIME
#define	TESTNAME(name)	"rkt_" name "_rt"
#else
#define	TESTNAME(name)	"rkt_" name
#endif

#endif	// __TESTER_H
