/***************************************************************************
    file	         : complink.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<cppunit/TestCase.h>
#include	<cppunit/TestCaller.h>
#include	<cppunit/TestSuite.h>

#include	<qstring.h>
#include	<qmap.h>

#if		defined(__WIN32__)
#define		_STDSTR(s)	((s).isNull() ? "" : (std::string)(s).latin1())
#define		EXPORT_API	__declspec(dllexport)
#endif
#if		! defined(__WIN32__)
#define		_STDSTR(s)	(s)
#define		EXPORT_API
#endif



extern	CppUnit::Test	*buttonTestSuite		(const QMap<QString,QString> *) ;

CppUnit::Test EXPORT_API *testSetup
	(	const QMap<QString,QString> *settings
	)
{
	CppUnit::TestSuite *suite = new CppUnit::TestSuite ("KBase") ;
	suite->addTest (buttonTestSuite	(settings))	;
	return	suite	;
}


#include	"kb_libloader.h"
#include	"factory.h"

TESTFACTORY	(KBTestAPIFactory,API,rkt_api)
