/***************************************************************************
    file	         : forms.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<stdio.h>
#include	<errno.h>
#include	<unistd.h>

#include	<qfile.h>
#include	<qmainwindow.h>

#include	"kb_classes.h"
#include	"kb_location.h"
#include	"kb_display.h"
#include	"kb_compaccessdlg.h"



#if		__KB_KDE
#include	<kapp.h>
#include	<klocale.h>
#include	<kaboutdata.h>
#include	<kcmdlineargs.h>
#endif

#define		SKELL	"forms"
#define		SKELU	"Forms"

static	FILE	*errfile	;


int	main
	(	int	argc,
		char	*argv[]
	)
{
	cchar	*sstde	= getenv ("REKALL_SHOWSTDERR") ;

	if ((sstde == 0) || (strcmp(sstde, "YES") != 0))
	{
		freopen	("/dev/null", "w", stderr) ;
		errfile	= fopen ("/dev/tty",  "w") ;
	}
	else	errfile	= stderr ;

#if	__KB_KDE
	char *dummy[2]	;

	dummy[0] = (char *)"script" ;
	dummy[1] = 0	;

	KAboutData about ("rekall",
			  I18N_NOOP("Rekall" SKELU "Test"),
			  "0.0.0",
			  I18N_NOOP("Rekall: " SKELU " test harness"),
			  KAboutData::License_Unknown,
			  "(c) 2000,2001,2002 by theKompany.com",
			  0,
			  "http://www.rekall.a-i-s.co.uk",
			  "mike@quaking.demon.co.uk"
			 ) ;
	about.addAuthor  ("Mike Richardson", 0, "mike@quaking.demon.co.uk") ; 
	about.addAuthor  ("John Dean", 	     0, "john@rygannon.com") ; 

	KCmdLineArgs::init (2, dummy, &about) ;

	KApplication	app	;
#endif
#if	__KB_TKC
	QApplication	app	(argc, argv) ;
#endif

	extern	void    registerAllNodes() ;
	registerAllNodes   () ;

	KBError		error	;
	bool		exec	= false	;

	argc	-= 1	;
	argv	+= 1	;

	while ((argc > 0) && (qstrncmp (argv[0], "--", 2) == 0))
	{
		if (qstrcmp (argv[0], "--exec") == 0)
		{
			exec	= true	;
			argv	+= 1	;
			argc	-= 1	;
			continue	;
		}

		fprintf	(errfile, "usage: " SKELL " [--exec] compfile\n") ;
		exit	(1) ;
	}

	if (argc != 1)
	{
		fprintf	(errfile, "usage: " SKELL " [--exec] compfile\n") ;
		exit	(1) ;
	}

	KBComponentLoadDlg clDlg
			(	0,
				QString::null,
				"py",
				QSize(300,50),
				true,
				KB::ObjForm
			)	;

	clDlg.show ()	;

	extern	void	printWidgetTree
		(	QWidget		*widget,
			uint		indent,
			FILE		*out
		)	;

	clDlg.stockSelected ("Buttons/Search") ;
	printWidgetTree (clDlg.topWidget(), 0, stdout) ;
	clDlg.stockSelected ("Buttons/Add") ;
	printWidgetTree (clDlg.topWidget(), 0, stdout) ;
	clDlg.stockSelected ("Navigation/Selector") ;
	printWidgetTree (clDlg.topWidget(), 0, stdout) ;

	if (exec) app.exec () ;

	return	0 ;
}
