/***************************************************************************
    file	         : accessor.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#if		defined(__WIN32__)
#define		EXPORT_API	__declspec(dllexport)
#endif
#if		! defined(__WIN32__)
#define		EXPORT_API
#endif

#include	"accessor.h"

#include	"kb_object.h"
#include	"kb_item.h"
#include	"kb_form.h"
#include	"kb_ctrl.h"


EXPORT_API
	KBControl *KBTestAccessor::getControl
		  (	KBObject 	*object
		  )
{
	return	object->m_control ;
}

EXPORT_API
	KBControl *KBTestAccessor::getControl
		  (	KBItem 		*item,
			uint		qrow
		  )
{
	return	item->ctrlAtQRow (qrow) ;
}

EXPORT_API
	bool	KBTestAccessor::eventFilter
		(	KBControl	*ctrl,
			QObject		*o,
			QEvent		*e
		)
{
	return	ctrl->eventFilter (o, e) ;
}

EXPORT_API
	bool	KBTestAccessor::setAttibute
		(	KBNode		*node,
			const QString	&name,
			const QString	&value
		)
{
	KBAttr	*attr	= node->getAttr (name) ;

	if (attr != 0)
	{
		attr->setValue (value) ;
		return	true	;
	}

	return	false	;
}

EXPORT_API
	KBEvent	*KBTestAccessor::findEvent
		(	KBObject	*object,
			const QString	&name
		)
{
	KBAttr 	*attr	= object->getAttr (name) ;
	return	attr == 0 ? 0 : attr->isEvent () ;
}

EXPORT_API
	bool	KBTestAccessor::eventHook
		(	KBObject	*object,
			KBEvent		&event,
			uint		argc,
			KBValue		*argv,
			bool		&evRc,
			bool		defval
		)
{
	return	object->eventHook (event, argc, argv, evRc, defval) ;
}

EXPORT_API
	QPtrList<KBNode>
	KBTestAccessor::insertHere
	(	KBObject		*target,
		QPtrList<KBNode>	&nodes,
		KBDisplay		*display,
		QRect			insertAt
	)
{
#if	__KB_RUNTIME
	return	QPtrList<KBNode>() ;
#else
	return	target->insertHere (nodes, display, insertAt) ;
#endif
}

EXPORT_API
	KBItem	*KBTestAccessor::currentItem
		(	KBForm		*form
		)
{
	return	form->m_formCurItem	;
}

EXPORT_API
	uint	KBTestAccessor::currentQRow
		(	KBForm		*form
		)
{
	return	form->m_formCurQRow	;
}
