/***************************************************************************
    file	         : api_if.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__TEST__API_IF_H
#define		__TEST__API_IF_H

#include	<cppunit/TestCase.h>
#include	<cppunit/TestCaller.h>
#include	<cppunit/TestSuite.h>
#include	<cppunit/extensions/HelperMacros.h>

#if		defined(__WIN32__)
#define		_STDSTR(s)	((s).isNull() ? "" : (std::string)(s).latin1())
#define		EXPORT_APIIF	__declspec(dllexport)
#endif
#if		! defined(__WIN32__)
#define		_STDSTR(s)	(s)
#define		EXPORT_APIIF
#endif

class	KBItem		;
class	KBLabel		;
class	KBButton	;
class	KBField		;
class	KBChoice	;
class	KBLink		;
class	KBMemo		;
class	KBRichText	;
class	KBListBox	;
class	KBControl	;
class	KBFormBlock	;
class	QLabel		;
class	RKLineEdit	;
class	RKComboBox	;
class	RKListBox	;
class	RKTextEdit	;
class	RKTextBrowser	;
class	KBSummary	;

class	EXPORT_APIIF	KBAPIIF : public CppUnit::TestCase
{
	KBControl		*getControl	(KBObject *, const char *) ;
	KBControl		*getControl	(KBItem   *, const char *, uint, uint) ;

protected :

	KBObject		*m_docroot	;

	KBObject		*getObject	(const char *, const char *, const char *) ;
	KBLabel			*getLabel	(const char *, const char *) ;
	KBButton		*getButton	(const char *, const char *) ;
	KBField			*getField	(const char *, const char *) ;
	KBChoice		*getChoice	(const char *, const char *) ;
	KBLink			*getLink	(const char *, const char *) ;
	KBMemo			*getMemo	(const char *, const char *) ;
	KBRichText		*getRichText	(const char *, const char *) ;
	KBListBox		*getListBox	(const char *, const char *) ;
	KBFormBlock		*getFormBlock	(const char *, const char *) ;
	KBSummary		*getSummary	(const char *, const char *) ;

	KBControl		*getControl	(KBLabel    *) ;
	KBControl		*getControl	(KBField    *) ;
	KBControl		*getControl	(KBField    *, uint, uint) ;
	KBControl		*getControl	(KBChoice   *) ;
	KBControl		*getControl	(KBChoice   *, uint, uint) ;
	KBControl		*getControl	(KBListBox  *) ;
	KBControl		*getControl	(KBListBox  *, uint, uint) ;
	KBControl		*getControl	(KBMemo     *) ;
	KBControl		*getControl	(KBMemo     *, uint, uint) ;
	KBControl		*getControl	(KBRichText *) ;
	KBControl		*getControl	(KBRichText *, uint, uint) ;
	RKLineEdit		*getRKLineEdit	(KBControl  *) ;
	RKComboBox		*getRKComboBox	(KBControl  *) ;
	RKListBox		*getRKListBox	(KBControl  *) ;
	RKTextEdit		*getRKTextEdit	(KBControl  *) ;
	RKTextBrowser		*getRKTextBrowser
						(KBControl  *) ;
	QLabel			*getQLabel	(KBControl  *) ;

	void			noDisplay	() ;
	void			withGUI		() ;

public	:

	KBAPIIF			() ;
	KBAPIIF			(std::string name) ;
}	;

#endif		// __TEST__API_IF_H
