/***************************************************************************
    file	         : kbase.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<cppunit/TestCase.h>
#include	<cppunit/TestCaller.h>
#include	<cppunit/TestRunner.h>
#include	<cppunit/TestSuite.h>

#include	<qstring.h>
#include	<qmap.h>

#if		defined(__WIN32__)
#define		EXPORT_API	__declspec(dllexport)
#endif
#if		! defined(__WIN32__)
#define		EXPORT_API
#endif


extern	CppUnit::Test	*attrTestSuite	(const QMap<QString,QString> *) ;
extern	CppUnit::Test	*skinTestSuite	(const QMap<QString,QString> *) ;

CppUnit::Test EXPORT_API *testSetup
	(	const QMap<QString,QString> *settings
	)
{
	CppUnit::TestSuite *suite = new CppUnit::TestSuite ("KBase") ;
	suite->addTest (attrTestSuite	 (settings))	;
	suite->addTest (skinTestSuite	 (settings))	;
	return	suite	;
}

#include	"kb_libloader.h"
#include	"factory.h"

TESTFACTORY	(KBTestKBaseFactory,KBase,rkt_kbase)
