/***************************************************************************
    file	         : tester_kbase.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__TESTER_KBASE_H
#define		__TESTER_KBASE_H

#if		defined(__WIN32__)
#define		IMPORT_API	__declspec(dllimport)
#endif
#if		! defined(__WIN32__)
#define		IMPORT_API
#endif

#include	<qstring.h>
#include	"kb_classes.h"
#include	"kb_location.h"

class		QWidget		;
class		KBDBInfo	;
class		KBForm		;
class		KBReport	;
class		KBError		;
class		KBWriter	;

extern	IMPORT_API
	void	rekallTestLoadScripting	() ;

class	IMPORT_API	TestOpenForm
{
public	:

	KBLocation	m_location	;
	QString		m_name		;
	KBForm		*m_form		;
	QWidget		*m_widget	;
	KB::ShowRC	m_showRC	;

	TestOpenForm	()		;
	~TestOpenForm	()		;
}	;

class	IMPORT_API	TestOpenReport
{
public	:

	KBLocation	m_location	;
	QString		m_name		;
	KBReport	*m_report	;
	QWidget		*m_widget	;
	KBWriter	*m_writer	;
	KB::ShowRC	m_showRC	;

	TestOpenReport	()		;
	~TestOpenReport	()		;
}	;

extern	IMPORT_API
	TestOpenForm
		*rekallTestOpenForm
		(	KBDBInfo	*dbInfo,
			const QString	&which,
			const QString	&name,
			KBError		&pError
		)	;

extern	IMPORT_API
	TestOpenForm
		*rekallTestOpenFormMode
		(	KBDBInfo	*dbInfo,
			const QString	&which,
			const QString	&name,
			KB::ShowAs	showAs,
			KBError		&pError
		)	;

extern	IMPORT_API
	TestOpenReport
		*rekallTestOpenReport
		(	KBDBInfo	*dbInfo,
			const QString	&which,
			const QString	&name,
			KBError		&pError
		)	;

extern	IMPORT_API
	TestOpenReport
		*rekallTestOpenReportMode
		(	KBDBInfo	*dbInfo,
			const QString	&which,
			const QString	&name,
			KB::ShowAs	showAs,
			KBError		&pError
		)	;

extern	IMPORT_API	void	rekallTestCloseForm   () ;
extern	IMPORT_API	void	rekallTestCloseReport () ;

#endif	// __TESTER_KBASE_H
